"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CompilerCache = void 0;
const lru_cache_1 = __importDefault(require("lru-cache"));
const QueryCache_1 = require("../adapter/QueryCache");
class CompilerCache extends QueryCache_1.QueryCache {
    queryCache;
    constructor({ maxQueryCacheSize, maxQueryCacheAge }) {
        super();
        this.queryCache = new lru_cache_1.default({
            max: maxQueryCacheSize || 10000,
            maxAge: (maxQueryCacheAge * 1000) || 1000 * 60 * 10,
            updateAgeOnGet: true
        });
    }
    getQueryCache(key) {
        const keyString = JSON.stringify(key);
        const exist = this.queryCache.get(keyString);
        if (exist) {
            return exist;
        }
        const result = new QueryCache_1.QueryCache();
        this.queryCache.set(keyString, result);
        return result;
    }
}
exports.CompilerCache = CompilerCache;
//# sourceMappingURL=CompilerCache.js.map